Subject: Re: [PATCH] net: fix setsockopt() locking errors

From: Jarek Poplawski <[email-masked]>
Date: Tue, 27 Jan 2009 08:45:26 +0000

On Mon, Jan 26, 2009 at 10:30:30PM +0100, Martin MOKREJŠ wrote:
> The patch really did not help:
> http://bugzilla.kernel.org/show_bug.cgi?id=12515#c5
> Martin

Actually, there is a little change: the warning triggerd in another
place (sock_setsockopt() -> sk_attach_filter()). So we could go deeper
with these changes, but I'm not sure this is the right way to fix.

It looks like the scenario is very old, but probably wasn't reported
(maybe there is some lockdep improvement):

A) sys_mmap2() -> mm->mmap_sem -> packet_mmap() -> sk_lock
B) sock_setsockopt() -> sk_lock -> copy_from_user() -> mm->mmap_sem

packet_mmap() (net/packet/af_packet.c) seems to be the only place in
net to implement mmap method, and using this lock order btw. On the
other hand copy_from_user() could be more popular under sk_lock, and
I'm not sure these changes are necessary.

Since I don't know enough neither sock/packet nor sys_mmap, I guess
some advice would be precious. It looks like Peter Zijlstra solved
similar problems in nfs, so I CC him.

Thanks,
Jarek P.

> 
> Jarek Poplawski wrote:
> > On 24-01-2009 23:49, Vegard Nossum wrote:
> >> Hi,
> >>
> >> This survives basic testing here, but I don't know what that counts for
> >> when I couldn't reproduce the lockdep report in the first place. Please
> >> review.
> >>
> >>
> >> Vegard
> >>
> >>
> >> From cc8bcd1c4fd219a31d6d191aefa4b4b57dadb9b0 Mon Sep 17 00:00:00 2001
> >> From: Vegard Nossum <[email-masked]>
> >> Date: Sat, 24 Jan 2009 22:44:16 +0100
> >> Subject: [PATCH] net: fix setsockopt() locking errors
> >> MIME-Version: 1.0
> >> Content-Type: text/plain; charset=utf-8
> >> Content-Transfer-Encoding: 8bit
> >>
> >> Martin MOKREJ.  <[email-masked]> reported:
> >>> =======================================================
> >>> [ INFO: possible circular locking dependency detected ]
> >>> 2.6.29-rc2-git1 #1
> >>> -------------------------------------------------------
> >>> tcpdump/3734 is trying to acquire lock:
> >>>  (&mm->mmap_sem){----}, at: [<c1053294>] might_fault+0x30/0x6b
> >>>
> >>> but task is already holding lock:
> >>>  (sk_lock-AF_PACKET){--..}, at: [<c12798c8>] sock_setsockopt+0x12b/0x4a4
> >>>
> >>> which lock already depends on the new lock.
> >> It turns out that sock_setsockopt() is calling copy_from_user() while
> >> holding the lock on the socket.
> > 
> > I guess it has been like this for some time, so it would be nice to
> > mention what scenario happens here, or IOW what exactly needs to get
> > these locks in reverse order.
> > 
> >> We fix it by splitting the ioctl code
> >> so that one switch handles the ioctls that have their own code for
> >> reading from userspace, and one switch handles the cases that require
> >> no additional reading.
> >>
> >> Reported-by: Martin MOKREJ.  <[email-masked]>
> >> Signed-off-by: Vegard Nossum <[email-masked]>
> >> ---
> >>  net/core/sock.c |  134 +++++++++++++++++++++++++++++++++++-------------------
> >>  1 files changed, 87 insertions(+), 47 deletions(-)
> >>
> >> diff --git a/net/core/sock.c b/net/core/sock.c
> >> index f3a0d08..6bd618d 100644
> >> --- a/net/core/sock.c
> >> +++ b/net/core/sock.c
> >> @@ -424,6 +424,80 @@ out:
> >>  	return ret;
> >>  }
> >>  
> >> +static int sock_linger(struct sock *sk, char __user *optval, int optlen)
> > ...
> >> +static int sock_set_rcvtimeo(struct sock *sk, char __user *optval, int optlen)
> >> +{
> >> +	int ret;
> >> +	long rcvtimeo;
> >> +
> >> +	ret = sock_set_timeout(&rcvtimeo, optval, optlen);
> > 
> > A check for error is needed here and below.
> > 
> [cut]